"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CodeRenderer = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var _reactUid = require("react-uid");

var _makeStyles = _interopRequireDefault(require("@material-ui/core/styles/makeStyles"));

var _reactCodemirror = require("react-codemirror2");

var _CodeProvider = require("@ui-schema/material-code/CodeProvider/CodeProvider");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var useStyles = (0, _makeStyles["default"])({
  root: {
    flex: '1 1 auto',
    marginTop: 0,
    height: '100%',
    position: 'relative',
    '& .CodeMirror': {
      position: 'absolute',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      height: '100%'
    }
  }
});

var CodeRenderer = function CodeRenderer(_ref) {
  var _editor$display, _editor$display$lineD;

  var storeKeys = _ref.storeKeys,
      schema = _ref.schema,
      value = _ref.value,
      onChange = _ref.onChange,
      valid = _ref.valid,
      required = _ref.required,
      format = _ref.format;
  var uid = (0, _reactUid.useUID)();

  var _useWidgetCode = (0, _CodeProvider.useWidgetCode)(),
      theme = _useWidgetCode.theme,
      modes = _useWidgetCode.modes;

  var _React$useState = _react["default"].useState(1),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      lines = _React$useState2[0],
      setLines = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(),
      _React$useState4 = (0, _slicedToArray2["default"])(_React$useState3, 2),
      editor = _React$useState4[0],
      setEditor = _React$useState4[1];

  var _React$useState5 = _react["default"].useState(false),
      _React$useState6 = (0, _slicedToArray2["default"])(_React$useState5, 2),
      focused = _React$useState6[0],
      setFocused = _React$useState6[1];

  var classes = useStyles();

  _react["default"].useEffect(function () {
    onChange({
      storeKeys: storeKeys,
      scopes: ['valid'],
      type: 'set',
      schema: schema,
      required: required,
      data: {
        valid: valid
      }
    });
  }, [onChange, valid, storeKeys]);

  _react["default"].useEffect(function () {
    if (editor && editor.refresh) {
      editor.refresh();
    }
  }, [editor]);

  var height = 0;

  if (editor !== null && editor !== void 0 && (_editor$display = editor.display) !== null && _editor$display !== void 0 && (_editor$display$lineD = _editor$display.lineDiv) !== null && _editor$display$lineD !== void 0 && _editor$display$lineD.children && editor.display.lineDiv.children[0]) {
    height = editor.display.lineDiv.children[0].clientHeight;
  }

  if (editor !== null && editor !== void 0 && editor.display && editor.display.gutters && editor.display.wrapper) {
    if (schema.getIn(['view', 'bg']) !== true) {
      editor.display.gutters.style.background = 'transparent';
      editor.display.wrapper.style.background = 'transparent';
    }
  }

  var handleOnChange = _react["default"].useCallback(function (changedEditor) {
    setLines(changedEditor.doc.size);
  }, [setLines]);

  var handleBeforeChange = _react["default"].useCallback(function (editor, data, storeValue) {
    onChange({
      storeKeys: storeKeys,
      scopes: ['value'],
      type: 'set',
      schema: schema,
      required: required,
      data: {
        value: storeValue
      }
    });
  }, [onChange, storeKeys, required, schema]);

  var mode = modes !== null && modes !== void 0 && modes[format] ? modes[format] : format;

  var options = _react["default"].useMemo(function () {
    return _objectSpread({
      mode: mode,
      lineNumbers: true
    }, theme ? {
      theme: theme
    } : {});
  }, [format, theme, mode]);

  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      minHeight: '2rem',
      height: lines ? (lines + 1) * height + 6 : 'auto',
      position: 'relative'
    }
  }, /*#__PURE__*/_react["default"].createElement(_reactCodemirror.Controlled, {
    className: (0, _clsx["default"])(classes.root, 'uis-' + uid, 'MuiInput-underline', focused ? 'Mui-focused' : null),
    editorDidMount: setEditor,
    value: value,
    onBeforeChange: handleBeforeChange,
    onChange: handleOnChange,
    onFocus: function onFocus() {
      return setFocused(true);
    },
    onBlur: function onBlur() {
      return setFocused(false);
    },
    options: options
  }));
};

exports.CodeRenderer = CodeRenderer;