"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CodeSelectable = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _uiSchema = require("@ui-schema/ui-schema");

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _ArrowDropDown = _interopRequireDefault(require("@material-ui/icons/ArrowDropDown"));

var _LocaleHelperText = require("@ui-schema/ds-material/Component/LocaleHelperText/LocaleHelperText");

var _CodeRenderer = require("@ui-schema/material-code/CodeRenderer");

var _Trans = require("@ui-schema/ui-schema/Translate/Trans");

var _UIStore = require("@ui-schema/ui-schema/UIStore");

var _immutable = require("immutable");

var CodeSelectable = function CodeSelectable(props) {
  var valid = props.valid,
      showValidity = props.showValidity,
      _props$value = props.value,
      value = _props$value === void 0 ? (0, _immutable.List)() : _props$value,
      onChange = props.onChange,
      storeKeys = props.storeKeys,
      ownKey = props.ownKey,
      schema = props.schema,
      required = props.required,
      errors = props.errors;

  var _React$useState = _react["default"].useState(null),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      open = _React$useState2[0],
      setOpen = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(function () {
    return schema.get('formatDefault') || schema.getIn(['format', 0]);
  }),
      _React$useState4 = (0, _slicedToArray2["default"])(_React$useState3, 2),
      format = _React$useState4[0],
      setFormat = _React$useState4[1];

  if (process.env.NODE_ENV === 'development' && schema.get('format').size < 0) {
    console.log('CodeSelectable schema without available formats');
  }

  var valFormat = value.get(0);

  _react["default"].useEffect(function () {
    if (valFormat) {
      setFormat(valFormat);
    }
  }, [valFormat, setFormat]);

  var hideTitle = schema.getIn(['view', 'hideTitle']);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], {
    error: !valid && showValidity,
    style: {
      marginBottom: 12,
      display: 'block'
    },
    onClick: function onClick(e) {
      return setOpen(e.currentTarget);
    },
    onKeyDown: function onKeyDown(e) {
      return e.key === 'Enter' ? setOpen(e.currentTarget) : undefined;
    }
  }, !hideTitle ? (0, _uiSchema.beautifyKey)(ownKey, schema.get('tt')) + (required ? ' *' : '') : null, !hideTitle && ' (', /*#__PURE__*/_react["default"].createElement(_Trans.Trans, {
    text: 'formats.' + format
  }), !hideTitle && ') ', /*#__PURE__*/_react["default"].createElement(_ArrowDropDown["default"], {
    fontSize: 'inherit'
  })), /*#__PURE__*/_react["default"].createElement(_Menu["default"], {
    anchorEl: open,
    keepMounted: true,
    open: Boolean(open),
    onClose: function onClose() {
      return setOpen(null);
    }
  }, schema.get('format').toArray().map(function (f) {
    return /*#__PURE__*/_react["default"].createElement(_MenuItem["default"], {
      key: f,
      selected: f === format,
      onClick: function onClick() {
        setOpen(null);
        onChange({
          storeKeys: storeKeys.push(0),
          scopes: ['value'],
          type: 'set',
          schema: schema,
          required: required,
          data: {
            value: f
          }
        });
      }
    }, /*#__PURE__*/_react["default"].createElement(_Trans.Trans, {
      text: 'formats.' + f
    }));
  })), format && /*#__PURE__*/_react["default"].createElement(_CodeRenderer.CodeRenderer, (0, _extends2["default"])({}, props, {
    format: format,
    value: value.get(1),
    storeKeys: storeKeys.push(1)
  })), /*#__PURE__*/_react["default"].createElement(_LocaleHelperText.ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
};

exports.CodeSelectable = CodeSelectable;
exports.CodeSelectable = CodeSelectable = (0, _UIStore.extractValue)(CodeSelectable);